// Code generated by counterfeiter. DO NOT EDIT.
package loginfakes

import (
	"context"
	"sync"

	"gitlab.eclipse.org/eclipse/xfsc/tsa/login/internal/service/login"
)

type FakeToken struct {
	PublicKeysStub        func(context.Context) ([]interface{}, error)
	publicKeysMutex       sync.RWMutex
	publicKeysArgsForCall []struct {
		arg1 context.Context
	}
	publicKeysReturns struct {
		result1 []interface{}
		result2 error
	}
	publicKeysReturnsOnCall map[int]struct {
		result1 []interface{}
		result2 error
	}
	SignedJWTStub        func(string) (string, error)
	signedJWTMutex       sync.RWMutex
	signedJWTArgsForCall []struct {
		arg1 string
	}
	signedJWTReturns struct {
		result1 string
		result2 error
	}
	signedJWTReturnsOnCall map[int]struct {
		result1 string
		result2 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeToken) PublicKeys(arg1 context.Context) ([]interface{}, error) {
	fake.publicKeysMutex.Lock()
	ret, specificReturn := fake.publicKeysReturnsOnCall[len(fake.publicKeysArgsForCall)]
	fake.publicKeysArgsForCall = append(fake.publicKeysArgsForCall, struct {
		arg1 context.Context
	}{arg1})
	stub := fake.PublicKeysStub
	fakeReturns := fake.publicKeysReturns
	fake.recordInvocation("PublicKeys", []interface{}{arg1})
	fake.publicKeysMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeToken) PublicKeysCallCount() int {
	fake.publicKeysMutex.RLock()
	defer fake.publicKeysMutex.RUnlock()
	return len(fake.publicKeysArgsForCall)
}

func (fake *FakeToken) PublicKeysCalls(stub func(context.Context) ([]interface{}, error)) {
	fake.publicKeysMutex.Lock()
	defer fake.publicKeysMutex.Unlock()
	fake.PublicKeysStub = stub
}

func (fake *FakeToken) PublicKeysArgsForCall(i int) context.Context {
	fake.publicKeysMutex.RLock()
	defer fake.publicKeysMutex.RUnlock()
	argsForCall := fake.publicKeysArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeToken) PublicKeysReturns(result1 []interface{}, result2 error) {
	fake.publicKeysMutex.Lock()
	defer fake.publicKeysMutex.Unlock()
	fake.PublicKeysStub = nil
	fake.publicKeysReturns = struct {
		result1 []interface{}
		result2 error
	}{result1, result2}
}

func (fake *FakeToken) PublicKeysReturnsOnCall(i int, result1 []interface{}, result2 error) {
	fake.publicKeysMutex.Lock()
	defer fake.publicKeysMutex.Unlock()
	fake.PublicKeysStub = nil
	if fake.publicKeysReturnsOnCall == nil {
		fake.publicKeysReturnsOnCall = make(map[int]struct {
			result1 []interface{}
			result2 error
		})
	}
	fake.publicKeysReturnsOnCall[i] = struct {
		result1 []interface{}
		result2 error
	}{result1, result2}
}

func (fake *FakeToken) SignedJWT(arg1 string) (string, error) {
	fake.signedJWTMutex.Lock()
	ret, specificReturn := fake.signedJWTReturnsOnCall[len(fake.signedJWTArgsForCall)]
	fake.signedJWTArgsForCall = append(fake.signedJWTArgsForCall, struct {
		arg1 string
	}{arg1})
	stub := fake.SignedJWTStub
	fakeReturns := fake.signedJWTReturns
	fake.recordInvocation("SignedJWT", []interface{}{arg1})
	fake.signedJWTMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeToken) SignedJWTCallCount() int {
	fake.signedJWTMutex.RLock()
	defer fake.signedJWTMutex.RUnlock()
	return len(fake.signedJWTArgsForCall)
}

func (fake *FakeToken) SignedJWTCalls(stub func(string) (string, error)) {
	fake.signedJWTMutex.Lock()
	defer fake.signedJWTMutex.Unlock()
	fake.SignedJWTStub = stub
}

func (fake *FakeToken) SignedJWTArgsForCall(i int) string {
	fake.signedJWTMutex.RLock()
	defer fake.signedJWTMutex.RUnlock()
	argsForCall := fake.signedJWTArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeToken) SignedJWTReturns(result1 string, result2 error) {
	fake.signedJWTMutex.Lock()
	defer fake.signedJWTMutex.Unlock()
	fake.SignedJWTStub = nil
	fake.signedJWTReturns = struct {
		result1 string
		result2 error
	}{result1, result2}
}

func (fake *FakeToken) SignedJWTReturnsOnCall(i int, result1 string, result2 error) {
	fake.signedJWTMutex.Lock()
	defer fake.signedJWTMutex.Unlock()
	fake.SignedJWTStub = nil
	if fake.signedJWTReturnsOnCall == nil {
		fake.signedJWTReturnsOnCall = make(map[int]struct {
			result1 string
			result2 error
		})
	}
	fake.signedJWTReturnsOnCall[i] = struct {
		result1 string
		result2 error
	}{result1, result2}
}

func (fake *FakeToken) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.publicKeysMutex.RLock()
	defer fake.publicKeysMutex.RUnlock()
	fake.signedJWTMutex.RLock()
	defer fake.signedJWTMutex.RUnlock()
	copiedInvocations := map[string][][]interface{}{}
	for key, value := range fake.invocations {
		copiedInvocations[key] = value
	}
	return copiedInvocations
}

func (fake *FakeToken) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ login.Token = new(FakeToken)
